import { z } from "zod";
export const RecordIdValue = z.union([
    z.string(),
    z.number(),
    z.record(z.unknown()),
    z.array(z.unknown()),
]);
export class RecordId {
    constructor(tb, id) {
        Object.defineProperty(this, "tb", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "id", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.tb = z.string().parse(tb);
        this.id = RecordIdValue.parse(id);
    }
    toJSON() {
        return {
            tb: this.tb,
            id: this.id,
        };
    }
}
//# sourceMappingURL=recordid.js.map