export declare class SurrealDbError extends Error {
}
export declare class NoActiveSocket extends SurrealDbError {
    name: string;
    message: string;
}
export declare class NoConnectionDetails extends SurrealDbError {
    name: string;
    message: string;
}
export declare class UnexpectedResponse extends SurrealDbError {
    name: string;
    message: string;
}
export declare class InvalidURLProvided extends SurrealDbError {
    name: string;
    message: string;
}
export declare class EngineDisconnected extends SurrealDbError {
    name: string;
    message: string;
}
export declare class UnexpectedServerResponse extends SurrealDbError {
    readonly response: unknown;
    name: string;
    constructor(response: unknown);
}
export declare class UnexpectedConnectionError extends SurrealDbError {
    readonly error: unknown;
    name: string;
    constructor(error: unknown);
}
export declare class UnsupportedEngine extends SurrealDbError {
    readonly engine: string;
    name: string;
    message: string;
    constructor(engine: string);
}
export declare class ConnectionUnavailable extends SurrealDbError {
    name: string;
    message: string;
}
export declare class ResponseError extends SurrealDbError {
    readonly message: string;
    name: string;
    constructor(message: string);
}
export declare class NoNamespaceSpecified extends SurrealDbError {
    name: string;
    message: string;
}
export declare class NoDatabaseSpecified extends SurrealDbError {
    name: string;
    message: string;
}
export declare class NoTokenReturned extends SurrealDbError {
    name: string;
    message: string;
}
