import { z } from "zod";
export declare const RecordIdValue: z.ZodUnion<[z.ZodString, z.ZodNumber, z.ZodRecord<z.ZodString, z.ZodUnknown>, z.ZodArray<z.ZodUnknown, "many">]>;
export type RecordIdValue = z.infer<typeof RecordIdValue>;
export declare class RecordId<Tb extends string = string> {
    readonly tb: Tb;
    readonly id: RecordIdValue;
    constructor(tb: Tb, id: RecordIdValue);
    toJSON(): {
        tb: Tb;
        id: string | number | unknown[] | Record<string, unknown>;
    };
}
